package gonganxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/api"
	"shylinux.com/x/community/src/gonganxitong/model"
)

type meeting struct {
	Table
	order  string `data:"92"`
	role   string `data:"leader,worker"`
	fields string `data:"user_id,vendor"`
	config string `name:"config place_uid* user_uid* user_id* vendor*"`
	create string `name:"create subject* start_time*:select@date end_time*:select@date" role:"worker"`
	modify string `name:"modify subject* start_time*:select@date end_time*:select@date" role:"worker"`
	cancel string `name:"cancel" role:"worker"`
	enter  string `name:"enter" help:"入会" style:"notice" role:"worker"`
}

func (s meeting) Config(m *ice.Message, arg ...string) {
	s.InsertOrUpdate(m, arg, m.OptionSimple(model.PLACE_UID)...)
}
func (s meeting) Create(m *ice.Message, arg ...string) { s.cmdy(m, s.MeetingPost, arg...) }
func (s meeting) Modify(m *ice.Message, arg ...string) { s.cmdy(m, s.MeetingPut, arg...) }
func (s meeting) Cancel(m *ice.Message, arg ...string) { s.cmdy(m, s.MeetingCancel, arg...) }
func (s meeting) Enter(m *ice.Message, arg ...string)  { m.ProcessOpen(m.Option(model.LINK)) }
func (s meeting) List(m *ice.Message, arg ...string) {
	if s.cmdy(m.Options(s.PLACE_UID, arg[0]), s.MeetingList, arg[1:]...); m.Length() > 0 {
		if len(arg) == 1 {
			m.PushAction(s.Enter, s.Modify, s.Cancel).Action(s.Create).Display("")
		} else if m.IsMobileUA() {
			m.EchoQRCode(m.Append(model.LINK)).Display("").DisplayCSS("")
		} else {
			m.EchoQRCode(m.Append(model.LINK)).Display("").DisplayCSS("")
			// m.EchoIFrame(m.Append(model.LINK)).SetAppend()
		}
	}
}
func (s meeting) MeetingList(m *ice.Message, arg ...string)   {}
func (s meeting) MeetingPost(m *ice.Message, arg ...string)   {}
func (s meeting) MeetingPut(m *ice.Message, arg ...string)    {}
func (s meeting) MeetingCancel(m *ice.Message, arg ...string) {}

func init() { ice.TeamCtxCmd(meeting{Table: newTable()}) }

type MeetingVendor interface {
	UserList(m *ice.Message, arg ...string) *ice.Message
	MeetingList(m *ice.Message, arg ...string) *ice.Message
	MeetingPost(m *ice.Message, arg ...string) *ice.Message
	MeetingPut(m *ice.Message, arg ...string) *ice.Message
	MeetingCancel(m *ice.Message, arg ...string) *ice.Message
}

var meetingVendorKey string
var meetingVendorList = map[string]MeetingVendor{}

func MeetingVendorAdd(key string, vendor MeetingVendor) {
	meetingVendorKey, meetingVendorList[key] = key, vendor
}

func (s meeting) cmdy(m *ice.Message, action ice.Any, arg ...string) {
	if m.Option(model.AUTH_UID, s.authUID(m, m.Option(s.PLACE_UID))) == "" {
		return
	}
	msg := s.Select(m.Spawn(), model.PLACE_UID, m.Option(s.PLACE_UID))
	m.Options(model.USER_ID, msg.Append(model.USER_ID)).Cmdy(kit.Select(meetingVendorKey, msg.Append(model.VENDOR)), action, arg)
}
func (s meeting) authUID(m *ice.Message, arg ...string) string {
	if msg := m.Cmd(s.Place, s.Select, model.UID, arg[0]); msg.Append(model.AUTH_UID) == "" {
		m.Echo("本服务暂未申请认证，请到<用户名片>申请认证")
	} else if m.Cmd(api.RENZHENGSHOUQUAN_AUTH, s.Select, model.UID, msg.Append(model.AUTH_UID)).Append(model.AUTH_STATUS) != "2" {
		m.Echo("本服务认证申请中，请等待审批")
	} else {
		return m.Cmd(s.Street, s.Select, model.UID, msg.Append(s.STREET_UID)).Append(model.AUTH_UID)
	}
	return ""
}
